VERSION 5.00
Begin VB.UserControl VT100Control 
   ClientHeight    =   3600
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   4800
   BeginProperty Font 
      Name            =   "Terminal"
      Size            =   9
      Charset         =   255
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   ForeColor       =   &H8000000E&
   KeyPreview      =   -1  'True
   ScaleHeight     =   3600
   ScaleWidth      =   4800
   Begin VB.Timer cursor_timer 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   120
      Top             =   120
   End
End
Attribute VB_Name = "VT100Control"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

'basiert auf Public-Domain-Code von Ian Storrs
'http://storrs.home.ml.org/video/telnet.zip
'storrs@bellsouth.net

Option Explicit
Option Base 0

Event SendData(ch$)

Public Trace As Boolean

'Windows RECT structure
Private Type RECT
   Left    As Long
   Top     As Long
   Right   As Long
   bottom  As Long
End Type

Private Declare Function ScrollWindow Lib "user32" (ByVal hwnd As Long, ByVal XAmount As Long, ByVal YAmount As Long, lpRect As RECT, lpClipRect As RECT) As Long
Private Declare Function ScrollDC Lib "user32" (ByVal hdc As Long, ByVal dx As Long, ByVal dy As Long, lprcScroll As RECT, lprcClip As RECT, ByVal hRgnUpdate As Long, lprcUpdate As RECT) As Long
Private Declare Function PatBlt Lib "gdi32" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal dwRop As Long) As Long
Private Declare Function SetBkMode Lib "gdi32" (ByVal hdc As Long, ByVal nBkMode As Long) As Long
Private Declare Function TextOut Lib "gdi32" Alias "TextOutA" (ByVal hdc As Long, ByVal x As Long, ByVal y As Long, ByVal lpString As String, ByVal nCount As Long) As Long
Private Declare Function SetBkColor Lib "gdi32" (ByVal hdc As Long, ByVal crColor As Long) As Long
Private Declare Function GetBkColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetBkMode Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function GetTextColor Lib "gdi32" (ByVal hdc As Long) As Long
Private Declare Function PaintRgn Lib "gdi32" (ByVal hdc As Long, ByVal hRgn As Long) As Long

Private Declare Function SetTextColor Lib "gdi32" (ByVal hdc As Long, ByVal newcolor As Long) As Long
Private Declare Function IsCharAlpha Lib "user32" Alias "IsCharAlphaA" (ByVal cChar As Byte) As Long

'=================== Ternary raster operations ============
Private Const PATCOPY = &HF00021         ' (DWORD) dest = pattern
Private Const PATPAINT = &HFB0A09        ' (DWORD) dest = DPSnoo
Private Const PATINVERT = &H5A0049       ' (DWORD) dest = pattern XOR dest
Private Const DSTINVERT = &H550009       ' (DWORD) dest = (NOT dest)
Private Const BLACKNESS = &H42&          ' (DWORD) dest = BLACK
Private Const WHITENESS = &HFF0062       ' (DWORD) dest = WHITE
Private Const TRANSPARENT = 1
Private Const OPAQUE = 2

Private Const WordWrap = True
Private Const ResetToBlack = True

Private Const TabsPerPage = 40
Private Const LinesPerPage = 25
Private Const CharsPerLine = 80
Private Const LastTab = 20

Private LastLine As Integer
Private LastChar As Integer

Private ScrImage(LinesPerPage)     As String * CharsPerLine
Private ForeAttr(LinesPerPage)     As String * CharsPerLine
Private BackAttr(LinesPerPage)     As String * CharsPerLine

Private Norm_Attr                 As String * CharsPerLine
Private Blank_Line                As String * CharsPerLine

'   Used in API calls
Private TermTextColor             As Long
Private TermBkColor               As Long
Private lprcScroll                As RECT
Private lprcClip                  As RECT
Private hRgnUpdate                As Integer
Private lprcUpdate                As RECT

'   Flag to indicate that we're ready to run
Private FlagInitDone    As Boolean

'   Tabs handling
Private tabno                      As Integer
Private tab_table(TabsPerPage)     As Integer

Private VT52Mode        As Boolean
Private ForeAttribute   As String * 1 ' Current screen attibute (for any char output)
Private BackAttribute   As String * 1 ' Current screen attibute (for any char output)
Private CurX            As Integer    ' Actual current X position
Private CurY            As Integer    ' Actual current Y position
Private SavecurX        As Integer    ' Used to save current X position if requested by server
Private SavecurY        As Integer    ' Used to save current Y position if requested by server
Private SaveForeAttr    As String     ' Used to save current attribute
Private SaveBackAttr    As String
Private InEscape        As Boolean    ' Processing an escape sequence
Private EscString       As String     ' String so far

Private charheight      As Single     ' Height font metric
Private charWidth       As Single     ' Width font metric

Private CurState        As Boolean    ' Caret state
Private ret             As Long       ' Don't care return value holder
Private Display         As Form
Private Receiving       As Boolean

Private Sub UserControl_Initialize()

LastLine = LinesPerPage
LastChar = CharsPerLine

Init
Receiving = False
Trace = False

End Sub

Public Function WriteChar(ch As Byte)

If (InEscape) Then
   Select Case ch
   Case 24, 26                            ' Cancel Escape
      InEscape = False
   Case vbKeyEscape                       ' Overlapping Escapes
      If Trace Then Debug.Print EscString & " - Throwing away this sequence !"
      EscString = ""                      ' Throw previous away
   Case Else
      If VT52Mode Then
         vt52_Process ch
      Else
         vt100_Process ch
      End If
   End Select
Else
   Select Case ch
   Case 0, 127                             ' Null
   Case 2 To 6                             ' ETX,EOT,ENQ
   Case 7                                  ' BELL
      Beep
   Case vbKeyBack                          ' Backspace
      CurX = CurX - 1
      vt100_validatecurX
   Case vbKeyTab
      Dim tX As Integer
      For tX = 1 To LastTab
         If CurX < tab_table(tX) Then Exit For
      Next tX
      CurX = tab_table(tX)
   Case 10, 11, 12                         ' LF, VT, FF
      If (CurY = LastLine) Then           '   if line left on scrn
         Call vt100_scroll_up             '   ..  scroll upwards
      Else
         CurY = CurY + 1                 '   goto next line
      End If
   Case vbKeyReturn                        ' CR
      CurX = 1
   Case 14, 15                            ' Select Char Set
   Case 17, 19                            ' Xon/XOff
   Case 24, 26                            ' Cancel Escape
      InEscape = False
   Case vbKeyEscape
      InEscape = True
      EscString = ""
   Case Else
      vt100_write ch
   End Select
End If

End Function

Public Property Let Cursor(enable As Boolean)
Static SaveState As Boolean

Receiving = Not enable
cursor_timer.Enabled = enable
If enable = False Then
   SaveState = CurState
   vt100_CursorHide
ElseIf SaveState = True Then
   vt100_CursorShow
End If

End Property

Public Property Get Cursor() As Boolean
Cursor = cursor_timer.Enabled
End Property

Private Sub vt100_CursorHide()

If CurState = True Then
   PatBlt UserControl.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, charWidth, charheight, DSTINVERT
   CurState = False
End If

End Sub

Private Sub vt100_CursorShow()

PatBlt UserControl.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, charWidth, charheight, DSTINVERT
CurState = True

End Sub

'erase from beginning of current line
Private Sub vt100_eraseBOL()

TextOut UserControl.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine

Mid$(ScrImage(CurY), 1, CurX) = Space$(CurX + 1)
Mid$(ForeAttr(CurY), 1, CurX) = String$(CurX + 1, Chr$(0))
Mid$(BackAttr(CurY), 1, CurX) = String$(CurX + 1, Chr$(0))

End Sub

'erase all lines from beginning of screen to and including current
Private Sub vt100_eraseBOS()
Dim y As Integer

'Erase the current line first
Call vt100_eraseBOL

'Erase everything up to current line
If (CurY > 0) Then
   TextOut UserControl.hdc, 0, 0, Space$(CharsPerLine * (CurY - 1) + CurX - 1), CharsPerLine * CurY + CurX

   ' reset screen buffer contents
   For y = 1 To CurY
      ScrImage(y) = Blank_Line
      ForeAttr(y) = Norm_Attr
      BackAttr(y) = Norm_Attr
   Next y
End If
End Sub

Private Sub vt100_eraseBUFFER()
Dim I As Integer
For I = 1 To LinesPerPage
   ScrImage(I) = Blank_Line
   ForeAttr(I) = Norm_Attr
   BackAttr(I) = Norm_Attr
Next I
End Sub

'erase to End of Line
Private Sub vt100_eraseEOL()

ret = TextOut(UserControl.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, Space$(CharsPerLine - CurX), CharsPerLine - CurX)

'Update screen buffer
Mid$(ScrImage(CurY), CurX, CharsPerLine - CurX) = Space$(CharsPerLine - CurX)
Mid$(ForeAttr(CurY), CurX, CharsPerLine - CurX) = String$(CharsPerLine - CurX, Chr$(0))
Mid$(BackAttr(CurY), CurX, CharsPerLine - CurX) = String$(CharsPerLine - CurX, Chr$(0))

End Sub

'erase to end of screen
Private Sub vt100_eraseEOS()
Dim y As Integer

Call vt100_eraseEOL
If (CurY <> LastLine) Then
   ret = TextOut(UserControl.hdc, 0, CurY * charheight, Space$((LastLine - CurY) * CharsPerLine), (LastLine - CurY) * CharsPerLine)
   For y = CurY + 2 To LinesPerPage
      ScrImage(y) = Blank_Line
      ForeAttr(y) = Norm_Attr
      BackAttr(y) = Norm_Attr
   Next y
End If

End Sub

'erase Line
Private Sub vt100_eraseLINE()

ret = TextOut(UserControl.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine)

ScrImage(CurY + 1) = Blank_Line
ForeAttr(CurY + 1) = Norm_Attr
BackAttr(CurY + 1) = Norm_Attr

End Sub

Private Sub vt100_eraseSCREEN()

vt100_eraseBUFFER

'Do they want to repaint using the latest background color ?
If Not ResetToBlack Then
   UserControl.BackColor = GetBkColor(UserControl.hdc)
   UserControl.ForeColor = GetTextColor(UserControl.hdc)
Else
   UserControl.ForeColor = QBColor(0)
   UserControl.ForeColor = QBColor(15)
End If
UserControl.Cls
CurX = 1
CurY = 1

End Sub

Private Function vt100_escapeParseArg(S As String) As String

'PopArg takes the next argument (digits up to a ;) and returns it.
'It also removes the arg and the ; from the input string "s"

Dim I As Integer

I = InStr(S, ";")
If I = 0 Then
   vt100_escapeParseArg = S
   S = ""
Else
   vt100_escapeParseArg = Left$(S, I - 1)
   S = Mid$(S, I + 1)
End If

End Function

Private Sub InitSize()

'Get the pixel metrics of the current font
UserControl.FontUnderline = False
UserControl.FontItalic = False
UserControl.FontBold = False

'Set up the vt100 screen using character M to get width of characters (could use API also)
UserControl.ScaleMode = 1
UserControl.Height = (UserControl.Height - UserControl.ScaleHeight) + LinesPerPage * UserControl.TextHeight("M")
UserControl.Width = (UserControl.Width - UserControl.ScaleWidth) + CharsPerLine * UserControl.TextWidth("M")

End Sub

Public Sub Init()

'The font must be a fixed font, not proportional
'For ANSI graphics you must use the TERMINAL font or equivalent

UserControl.Cls
InitSize

UserControl.ScaleMode = 3
charheight = UserControl.TextHeight("M")
charWidth = UserControl.TextWidth("M")

'Set the user scale of the display
UserControl.ScaleMode = 0
UserControl.ScaleWidth = LinesPerPage
UserControl.ScaleWidth = CharsPerLine
UserControl.Scale (0, 0)-(LastChar, LastLine)

'Set up the scoll region and clip region structures for API calls
lprcScroll.Top = 0
lprcScroll.Left = 0
lprcScroll.Right = CharsPerLine * charWidth
lprcScroll.bottom = LinesPerPage * charheight
lprcClip = lprcScroll
hRgnUpdate = 0

'Initialize module level flags and variables
InEscape = False
CurState = False
ForeAttribute = Chr$(0)
BackAttribute = Chr$(0)
CurX = 1
CurY = 1

'Set the default foreground and background colors - use API so that TextOut works !
ret = SetBkMode(UserControl.hdc, OPAQUE)
UserControl.ForeColor = QBColor(7)
UserControl.BackColor = QBColor(0)
ret = SetTextColor(UserControl.hdc, QBColor(7))
ret = SetBkColor(UserControl.hdc, QBColor(0))

TermTextColor = GetTextColor(UserControl.hdc)
TermBkColor = GetBkColor(UserControl.hdc)
vt100_eraseBUFFER
vt100_resetTabs

'Initialize repaint buffers to speed up program at runtime
VT52Mode = False
Norm_Attr = String$(CharsPerLine, Chr$(0))
Blank_Line = Space$(CharsPerLine)

'Set a flag to avoid unnecessary repaints
FlagInitDone = True

cursor_timer.Enabled = False

End Sub

Private Function vt100_FindChange(InArray As String, ByVal CurrentValue As String, ByteLen As Integer) As Integer

' This subroutine attempts to find the next place on the Current Line where an attribute change occurs
' I used to have a 16 bit C DLL doing this for the VB3 version, but hope that using a byte array search will
' help in VB5 native code.


'Dim RetValue As Integer
Dim CurrentByte As Byte
Dim InByte() As Byte
Dim RetValue As Integer

CurrentByte = Asc(CurrentValue)
InByte = InArray
'
For RetValue = 0 To ByteLen Step 2
   If InByte(RetValue) <> CurrentByte Then
      Exit For
   End If
Next

vt100_FindChange = RetValue \ 2

' First Attempt at this used sting functions as follows :
' I think the byte array is faster, but you can try for yourself !

'Dim RetValue As Integer
'For RetValue = 1 To ByteLen
'    If Mid$(InArray, RetValue, 1) <> CurrentValue Then
'        Exit For
'    End If
'Next
'vt100_FindChange = RetValue - 1

End Function

Private Sub vt100_redrawscreen()
Dim oldcur          As Boolean
Dim oldattrforw     As String * 1
Dim oldattrback     As String * 1
Dim NewAttr         As String
Dim y               As Integer
Dim X1              As Integer
Dim X2              As Integer
Dim AttrChange      As Integer
Dim ForeAttrChange  As Integer
Dim BackAttrChange  As Integer
Dim tAttrFore       As String * CharsPerLine
Dim tAttrBack       As String * CharsPerLine
Dim tLine           As String * CharsPerLine

If FlagInitDone = False Then
   'Don't do this if the program is opening or the window is minimized !
   Exit Sub
End If

'Save the current caret state and attribute
'Change the attribute to "0" (undefined) for the purpose of the search
oldcur = CurState
oldattrforw = ForeAttribute
oldattrback = BackAttribute

vt100_redraw_attribute Chr$(0)

If Not Receiving Then
   'If not receiving data, hide the caret
   Call vt100_CursorHide
End If

For y = 1 To LinesPerPage
   tAttrFore = ForeAttr(y)
   tAttrBack = BackAttr(y)
   tLine = ScrImage(y)
   If (tAttrFore = Norm_Attr) And (tAttrBack = Norm_Attr) Then
      'Normal Lines can be repainted directly
      ret = TextOut(UserControl.hdc, 0, (y - 1) * charheight, tLine, CharsPerLine)
   Else
      'Complex lines must have attribute changes found using the
      'function vt100_FindChange.
      X1 = 1                          'Start the scan on the complete line
      X2 = CharsPerLine               'Don't go beyond the end of the line !
      Do While (X2 > 0)

         'Find the next change in fore and back attributes on this line
         'Use the lesser of the two changes
         ForeAttrChange = vt100_FindChange(Mid(tAttrFore, X1, X2), ForeAttribute, X2)
         BackAttrChange = vt100_FindChange(Mid(tAttrBack, X1, X2), BackAttribute, X2)
         If ForeAttrChange < BackAttrChange Then
            AttrChange = ForeAttrChange
         Else
            AttrChange = BackAttrChange
         End If

         'Redraw the subsection of this line with the current attributes
         ret = TextOut(UserControl.hdc, (X1 - 1) * charWidth, (y - 1) * charheight, Mid$(tLine, X1, AttrChange), AttrChange)

         'Now change to the new attributes for the remainder of this line
         X2 = X2 - AttrChange
         If X2 > 0 Then
            X1 = X1 + AttrChange
            If ForeAttrChange < BackAttrChange Then
               'Only update fore_attribute
               NewAttr = Mid$(tAttrFore, X1, 1)
               vt100_redraw_attribute NewAttr
            ElseIf ForeAttrChange > BackAttrChange Then
               'Only update back_attribute
               NewAttr = Mid$(tAttrBack, X1, 1)
               vt100_redraw_attribute NewAttr
            Else
               'Update both fore_attribute and back_attribute
               NewAttr = Mid$(tAttrFore, X1, 1)
               vt100_redraw_attribute NewAttr
               NewAttr = Mid$(tAttrBack, X1, 1)
               vt100_redraw_attribute NewAttr
            End If
         End If
      Loop
   End If
Next y

'Restore the previously saved caret state and attribute
vt100_redraw_attribute oldattrforw
vt100_redraw_attribute oldattrback
ForeAttribute = oldattrforw
BackAttribute = oldattrback
If Not Receiving Then
   If oldcur = True Then
      vt100_CursorShow
   End If
End If

End Sub

Private Sub vt100_scroll_up()

Dim I As Integer
Dim S As Integer

ret = ScrollDC(UserControl.hdc, 0, -charheight, lprcScroll, lprcClip, hRgnUpdate, lprcUpdate)
ret = TextOut(UserControl.hdc, 0, (CurY - 1) * charheight, Blank_Line, CharsPerLine)

'Update the redisplay buffer (only update the scrollable region)
'Might consider making this a circular array so only one line
'needs to be written per scroll, rather than relinking the array
S = (lprcScroll.Top \ charheight + 1)
For I = S To LastLine - 1
   ScrImage(I) = ScrImage(I + 1)
   ForeAttr(I) = ForeAttr(I + 1)
   BackAttr(I) = BackAttr(I + 1)
Next I
ScrImage(LinesPerPage) = Blank_Line
ForeAttr(LinesPerPage) = Norm_Attr
BackAttr(LinesPerPage) = Norm_Attr

End Sub

Private Sub vt100_setattr(ch As String)

Static LastTextColor As Long
Static LastBackColor As Long
Static BrightOn      As Integer
Static BlinkOn       As Boolean
Static UnderOn       As Boolean
Dim Attributes       As Integer

Attributes = Asc(ch)

Select Case Attributes
Case 0  '   Normal
   UserControl.FontUnderline = False
   UserControl.FontItalic = False
   UserControl.FontBold = False
   BrightOn = 0
   BlinkOn = False
   UnderOn = False

   'Must also reset colors to default
   ret = SetTextColor(UserControl.hdc, QBColor(7))
   ret = SetBkColor(UserControl.hdc, QBColor(0))
   ForeAttribute = Chr$(0)
   BackAttribute = Chr$(0)

Case 1  '   Bold
   BrightOn = 8

Case 2  '   Half  - Not Supported

Case 5 To 6  '   Blinking
   UserControl.FontItalic = True
   BlinkOn = True

Case 4  '   Underscore
   UserControl.FontUnderline = True

Case 7  '   Reverse Video
   ret = SetTextColor(UserControl.hdc, TermBkColor)
   ret = SetBkColor(UserControl.hdc, TermTextColor)

Case 8  '   Cancel (Invisible)
   'Save current actual colors
   LastTextColor = GetTextColor(UserControl.hdc)
   LastBackColor = GetBkColor(UserControl.hdc)

   'Set text and back colors the same
   ret = SetTextColor(UserControl.hdc, LastBackColor)

Case 21, 22
   BrightOn = 0
   UserControl.FontBold = False

Case 24
   UserControl.FontUnderline = False

Case 25
   BlinkOn = False
   UserControl.FontItalic = False

Case 27
   'Reset text and back colors the same
   ret = SetTextColor(UserControl.hdc, LastTextColor)

Case 30 To 37  'Foreground
   ret = SetTextColor(UserControl.hdc, QBColor(BrightOn + vt100_ColorNumber(Attributes - 30)))
   If BrightOn = 8 Then Attributes = Attributes + 30
   If UnderOn = True Then Attributes = Attributes + 60
   ForeAttribute = Chr$(Attributes)

Case 40 To 47  'Background
   ret = SetBkColor(UserControl.hdc, QBColor(vt100_ColorNumber(Attributes - 40)))
   If BlinkOn = True Then Attributes = Attributes + 30
   BackAttribute = Chr$(Attributes)

Case Else
   'Debug.Print "What???"; Asc(CH)

End Select

End Sub

Private Sub vt100_redraw_attribute(Attributes As String)

Static LastTextColor As Long
Static LastBackColor As Long

Select Case Asc(Attributes)
Case 0  '   Normal
   UserControl.FontUnderline = False
   UserControl.FontItalic = False
   UserControl.FontBold = False

   'Must also reset colors to default
   ret = SetTextColor(UserControl.hdc, QBColor(7))
   ret = SetBkColor(UserControl.hdc, QBColor(0))
   ForeAttribute = Chr$(0)
   BackAttribute = Chr$(0)

Case 1  '   Bold
   'Do Nothing

Case 2  '   Half  - Not Supported
   'Do Nothing

Case 5  '   Blinking

Case 4  '   Underscore
   'UserControl.FontUnderline = True

Case 7  '   Reverse Video
   ret = SetTextColor(UserControl.hdc, TermBkColor)
   ret = SetBkColor(UserControl.hdc, TermTextColor)

Case 8  '   Cancel (Invisible)
   'Save current actual colors
   LastTextColor = GetTextColor(UserControl.hdc)
   LastBackColor = GetBkColor(UserControl.hdc)

   'Set text and back colors the same
   ret = SetTextColor(UserControl.hdc, LastBackColor)

Case 21, 22 'Unbold
   'Do Nothing

Case 24
   'UserControl.FontUnderline = False

Case 25
   UserControl.FontItalic = False
   'Blinking Off

Case 27
   'Reset text and back colors the same
   ret = SetTextColor(UserControl.hdc, LastTextColor)
   'Debug.Print "Invisible Off"

Case 30 To 37  'Foreground
   ret = SetTextColor(UserControl.hdc, QBColor(vt100_ColorNumber(Asc(Attributes) - 30)))
   UserControl.FontUnderline = False
   ForeAttribute = Attributes

Case 40 To 47  'Background
   UserControl.FontItalic = False
   ret = SetBkColor(UserControl.hdc, QBColor(vt100_ColorNumber(Asc(Attributes) - 40)))
   BackAttribute = Attributes

Case 60 To 67  'Light Foreground
   UserControl.FontUnderline = False
   ret = SetTextColor(UserControl.hdc, QBColor(8 + vt100_ColorNumber(Asc(Attributes) - 60)))
   ForeAttribute = Attributes

Case 70 To 77  'Light Background
   ret = SetBkColor(UserControl.hdc, QBColor(8 + vt100_ColorNumber(Asc(Attributes) - 70)))
   UserControl.FontItalic = True
   BackAttribute = Attributes

Case 90 To 97  'Foreground
   ret = SetTextColor(UserControl.hdc, QBColor(vt100_ColorNumber(Asc(Attributes) - 90)))
   UserControl.FontUnderline = True
   ForeAttribute = Attributes

Case 120 To 127 'Foreground
   ret = SetTextColor(UserControl.hdc, QBColor(8 + vt100_ColorNumber(Asc(Attributes) - 120)))
   UserControl.FontUnderline = True
   ForeAttribute = Attributes

Case Else
   'Debug.Print "What???"; Asc(CH)

End Select

End Sub
Private Sub vt100_validatecurX()
If (CurX < 1) Then
   CurX = 1
ElseIf CurX > LastChar Then
   If WordWrap = True Then
      CurX = 1
      If (CurY = LastLine) Then vt100_scroll_up Else CurY = CurY + 1
   Else
      CurX = LastChar
   End If
End If
End Sub

Private Sub vt100_validatecurY()
If (CurY < 1) Then
   CurY = 1
ElseIf CurY > LastLine Then
   CurY = LastLine
End If
End Sub

Private Sub vt100_write(ch As Byte)
' This subroutine has 3 purposes
' 1. Write a character to the screen if the form is not minimized
' 2. Save that character and it's attribute in the repaint buffer
' 3. Move the cursor over one character, and if necessary do wordwrapping/scroll

ret = TextOut(UserControl.hdc, (CurX - 1) * charWidth, (CurY - 1) * charheight, Chr$(ch), 1)

Mid$(ScrImage(CurY), (CurX), 1) = Chr$(ch)      ' save this character
Mid$(ForeAttr(CurY), (CurX), 1) = ForeAttribute ' and its attributes
Mid$(BackAttr(CurY), (CurX), 1) = BackAttribute ' and its attributes

If Not (CurX = LastChar) Then
   CurX = CurX + 1
ElseIf WordWrap Then
   CurX = 1
   If (CurY = LastLine) Then vt100_scroll_up Else CurY = CurY + 1
End If

End Sub

'parse and process a subset of VT52 mode sequences
Private Sub vt52_Process(ch As Byte)

Select Case Chr$(ch)
Case "A"  ' A ==> move cursor up
   CurY = CurY - 1: vt100_validatecurY

Case "B"  ' B ==> move cursor down
   CurY = CurY + 1: vt100_validatecurY

Case "C"  ' C ==> move cursor right
   CurX = CurX + 1: vt100_validatecurX

Case "D"  ' D ==> move cursor left
   CurX = CurX - 1: vt100_validatecurX

Case "H"  'Home Cursor
   CurY = 1: vt100_validatecurY
   CurX = 1: vt100_validatecurX

Case "J"  'Erase to end of screen
   vt100_eraseEOS

Case "K"  'Erase to end of screen
   vt100_eraseEOL

Case "Z"  'Identify
   RaiseEvent SendData(Chr$(27) & "/Z")         'VT52 default response

Case "<"  'Change to ANSI mode
   VT52Mode = False

Case Else
   'E=Line Feed, F=Special Character set, G=ASCII Character set
   'W=Print Controller On, X=Print Controller Off, Y=Cursor Address
   ']=Print Screen, ^=Auto Print On, -=Auto Print Off, ==Alternate Keypad
   '>=Numeric Keypad, I=VT52 Reverse line feed
   If Trace Then Debug.Print "Unsupported VT52 Escape Sequence: " & Chr$(ch)

End Select

InEscape = False
EscString = ""

End Sub

Private Sub vt100_Process(ch As Byte)
Const Usup = "Unsupported VT100 Escape Sequence: "
Dim C           As String
Dim yDiff       As Integer
Dim xDiff       As Integer
Dim I           As Integer

' This subroutine parses and processes a subset of VT100 mode sequences

C = Chr$(ch)
If EscString = "" Then
   'No start character yet
   Select Case C
   Case "["                'ESC[
      If Trace Then Debug.Print "VT100 ESC";
      EscString = "["
      Exit Sub

   Case "7"                 ' save cursor
      'Save cursor position
      SavecurX = CurX
      SavecurY = CurY
      SaveForeAttr = ForeAttribute
      SaveBackAttr = BackAttribute

      If Trace Then Debug.Print "VT100 ESC[7"; CurY; CurX; Asc(ForeAttribute); Asc(BackAttribute)
      InEscape = False
      Exit Sub
      
   Case "8"                 ' restore cursor
      'restore cursor position
      CurX = SavecurX
      CurY = SavecurY
      ForeAttribute = SaveForeAttr
      BackAttribute = SaveBackAttr
      vt100_setattr ForeAttribute
      vt100_setattr BackAttribute

      If Trace Then Debug.Print "VT100 ESC[8"; CurY; CurX; Asc(ForeAttribute); Asc(BackAttribute)
      InEscape = False
      Exit Sub

   Case "c"                 ' look at VSIreset()
      ' Hard terminal reset
      If Trace Then Debug.Print "VT100 ESC[c"
      Init
      InEscape = False
      Exit Sub

   Case "D"                 ' index / cursor down
      If Trace Then Debug.Print "VT100 ESC[D"
      CurY = CurY + 1
      vt100_validatecurY
      InEscape = False
      Exit Sub

   Case "E"                 ' new line
      If Trace Then Debug.Print "VT100 ESC[E"
      CurX = 1
      CurY = CurY + 1
      vt100_validatecurY
      vt100_validatecurX
      InEscape = False
      Exit Sub

   Case "H"                 ' set tab
      If Trace Then Debug.Print "VT100 ESC[H"
      If tabno <= TabsPerPage Then tab_table(tabno) = CurX
      tabno = tabno + 1
      InEscape = False
      Exit Sub

   Case "I"                 ' look at bp_ESC_I()
      InEscape = False
      Exit Sub

   Case "M"                 ' reverse index / cursor up
      If Trace Then Debug.Print "VT100 ESC[M"
      CurY = CurY - 1
      vt100_validatecurY
      InEscape = False
      Exit Sub

   Case "P"                 ' look at VSIreset()
      ' Start of a Device Control Sequence
      If Trace Then Debug.Print "VT100 ESC[P"
      InEscape = False
      Exit Sub

   Case "Z"                 ' send identity
      ' DEC Device Attributes - respond as VT100
      If Trace Then Debug.Print "VT100 ESC[Z"
      RaiseEvent SendData(Chr$(27) & "[?1;0c")  'VT100 default response
      InEscape = False
      Exit Sub
      
   Case Else
      'Invalid start of escape sequence
      'or:
      ']=OSC Operating System Command
      '^=PM Privacy Mode
      '!=Unknown BBS Sequence
      '_=APC Application Program Command
      'n=LS2, o=LS3, |=LS3R, }=LS2R, ~=LS1R, #=Escape Square
      If Trace Then Debug.Print Usup & "ESC[" & C
      InEscape = False
      Exit Sub
      
   End Select
End If

'Add the latest character to the escape sequence buffer
EscString = EscString & C
If IsCharAlpha(ch) = 0 Then ' Not a character ...
   If Len(EscString) > 15 Then
      'Sequence is too long. Throw it away
      If Trace Then Debug.Print Usup & "too long: "; EscString
      InEscape = False
   End If
   If C = "!" Then
      InEscape = False
      EscString = ""
   End If
   Exit Sub 'Wait for more characters
End If

'We must be finished
If Trace Then Debug.Print EscString;

Select Case C
Case "A" ' A ==> move cursor up
   EscString = Mid$(EscString, 2)
   yDiff = Val(vt100_escapeParseArg(EscString))
   If yDiff = 0 Then yDiff = 1
   CurY = CurY - yDiff
   vt100_validatecurY

Case "B" ' B ==> move cursor down
   EscString = Mid$(EscString, 2)
   yDiff = Val(vt100_escapeParseArg(EscString))
   If yDiff = 0 Then yDiff = 1
   CurY = CurY + yDiff
   vt100_validatecurY

Case "C" ' C ==> move cursor right
   EscString = Mid$(EscString, 2)
   xDiff = Val(vt100_escapeParseArg(EscString))
   If xDiff = 0 Then xDiff = 1
   CurX = CurX + xDiff
   vt100_validatecurX

Case "D" ' D ==> move cursor left
   EscString = Mid$(EscString, 2)
   xDiff = Val(vt100_escapeParseArg(EscString))
   If xDiff = 0 Then xDiff = 1
   CurX = CurX - xDiff
   vt100_validatecurX

Case "G" 'Cursor absolute position ????
   EscString = Mid$(EscString, 2)
   CurX = Val(EscString) - 1
   vt100_validatecurX

Case "H"
   'Goto cursor position indicated by escape sequence
   EscString = Mid$(EscString, 2)
   CurY = Val(vt100_escapeParseArg(EscString)) - 1
   vt100_validatecurY
   CurX = Val(EscString) - 1
   vt100_validatecurX

Case "J" 'Erase display
   Select Case Val(Mid$(EscString, 2))
   Case 0: If CurX = 1 And CurY = 1 Then vt100_eraseSCREEN Else vt100_eraseEOS
   Case 1: vt100_eraseBOS
   Case 2: vt100_eraseSCREEN
   End Select

Case "K" 'Erase line
   Select Case Val(Mid$(EscString, 2))
   Case 0: vt100_eraseEOL     'erase to end of line
   Case 1: vt100_eraseBOL     'erase to beginning of line
   Case 2: vt100_eraseLINE
   End Select

Case "S" 'cursor down
   CurY = CurY + 1: vt100_validatecurY

Case "T" 'cursor up
   CurY = CurY - 1: vt100_validatecurY

Case "U" 'Clear Screen
   vt100_eraseSCREEN

Case "b"
   ' Graphics Request
   ' boxes          ESC [ 1 <Row> ; <Col> ; <Wide> ; <High> ; <Att> b
   '                ESC [ 5 ; 3 0 b
   ' save screen    ESC [ 3 b
   ' restore screen ESC [ 4 b
   ' IMPLEMENT LATER

Case "c" 'DEC Device Attributes - respond as VT100
   RaiseEvent SendData(Chr$(27) & "[?1;0c")  'VT100 default response

Case "f" 'Same as H; Goto cursor position indicated by escape sequence
   EscString = Mid$(EscString, 2)
   CurY = Val(vt100_escapeParseArg(EscString))
   vt100_validatecurY
   CurX = Val(EscString)
   vt100_validatecurX

Case "g" 'reset tabs
   vt100_resetTabs

Case "h"
   EscString = Mid$(EscString, 2)
   Select Case Val(EscString)
   Case 0      ' Error - ignore
   Case 1      ' Change cursor keys application
   Case 2: VT52Mode = False ' Mode - VT102
   Case 6      ' Functions on in scroll region - don't ignore margins
   Case 7      ' Wordwrap on
   Case 25     ' Cursor on
   Case 255    ' Doorway on - cannot work with telnet
   End Select

Case "i" 'print though mode - ignore

Case "l" 'Set Options
   EscString = Mid$(EscString, 2)
   Select Case Val(EscString)
   Case 0      ' Error - ignore
   Case 1      ' Change cursor keys application vs Mode - VT52 or ANSI
   Case 2: VT52Mode = True      ' Mode - VT52
   Case 6      ' Functions off in scroll region - ignore margins
   Case 7      ' Wordwrap Off
   Case 25     ' Cursor Off
   Case 255    ' Doorway off - cannot work with telnet
   End Select

Case "m" 'Change text attributes, screen colors
   EscString = Mid$(EscString, 2)
   Do
      vt100_setattr Chr$(Val(vt100_escapeParseArg(EscString)))
   Loop While EscString <> ""

Case "n" 'Status Request - often used to assess ANSI compliance
   EscString = Mid$(EscString, 2)
   Select Case Val(EscString)
   Case 5 'Device Status
      RaiseEvent SendData(Chr$(27) & "[0n")  'OK
   Case 6 'Cursor Position
      RaiseEvent SendData(Chr$(27) & "[" & CStr(CurY) & ";" & CStr(CurX) & "R")
   End Select

Case "p" 'VT100 keyboard reassignment - ignore

Case "q" 'VT100 lights on/off - ignore

Case "r" 'Set scrollable region
   EscString = Mid$(EscString, 2)
   lprcScroll.Top = (Val(vt100_escapeParseArg(EscString)) - 1) * charheight
   lprcClip = lprcScroll

Case "s" 'Save cursor position
   SavecurX = CurX
   SavecurY = CurY
   SaveForeAttr = ForeAttribute
   SaveBackAttr = BackAttribute
   If Trace Then Debug.Print CurY; CurX; Asc(ForeAttribute); Asc(BackAttribute)

Case "u" 'restore cursor position
   CurX = SavecurX
   CurY = SavecurY
   ForeAttribute = SaveForeAttr
   BackAttribute = SaveBackAttr
   vt100_setattr ForeAttribute
   vt100_setattr BackAttribute
   If Trace Then Debug.Print CurY; CurX; Asc(ForeAttribute); Asc(BackAttribute)

Case "y" 'VT100 test - ignore
   'Esc [ 2 ; 8 y   Wait for poweroff.
   'Esc [ 2 ; 15 y  Flashing background mode.  Also puts terminal in local.

Case "z"
   'ANSI reset - ignore

Case Else
   'X=Print Controller Off
   'Z=BackTab
   '@=Insert Character
   't,_,!=Unknown BBS Sequence
   'Y=Delete line
   'W=Print Controller On
   'E=Line Feed
   'F=Special Character set
   'I=VT52 Reverse line feed
   'N=Ansi music
   'P=Delete current character
   'L=Insert Line
   'M=Delete Line
   If Trace Then Debug.Print Usup & EscString

End Select

If Trace Then Debug.Print
InEscape = False
EscString = ""

End Sub

Private Sub vt100_resetTabs()
Dim tX As Integer
For tX = 1 To LastTab
   tab_table(tX) = tX * 4
Next tX
End Sub

Private Sub cursor_timer_Timer()
If Receiving = False Then
   If CurState = False Then vt100_CursorShow Else vt100_CursorHide
End If
End Sub

'Translate keycodes to VT100 escape sequences
Private Sub UserControl_KeyDown(KeyCode As Integer, Shift As Integer)
Dim ch As String

ch = Chr$(0)

Select Case KeyCode
Case vbKeyEnd:   ch = Chr$(27) + "[K"
Case vbKeyHome:  ch = Chr$(27) + "[H"
Case vbKeyLeft:  ch = Chr$(27) + "[D"
Case vbKeyUp:    ch = Chr$(27) + "[A"
Case vbKeyRight: ch = Chr$(27) + "[C"
Case vbKeyDown:  ch = Chr$(27) + "[B"
Case vbKeyF1:    ch = Chr$(27) + "OP"
Case vbKeyF2:    ch = Chr$(27) + "OQ"
Case vbKeyF3:    ch = Chr$(27) + "OR"
Case vbKeyF4:    ch = Chr$(27) + "OS"
End Select

If ch <> Chr$(0) Then
   RaiseEvent SendData(ch)
End If

End Sub

Private Sub UserControl_KeyPress(KeyAscii As Integer)
Dim ch As String

ch = Chr$(KeyAscii)
If Len(ch) Then
   RaiseEvent SendData(ch)
End If

End Sub

Private Sub UserControl_Paint()

InitSize
vt100_redrawscreen

End Sub

Private Function vt100_ColorNumber(nr%) As Integer

Select Case nr%
Case 0:    vt100_ColorNumber = 0 'Black
Case 1:    vt100_ColorNumber = 4 'Red
Case 2:    vt100_ColorNumber = 2 'Green
Case 3:    vt100_ColorNumber = 6 'Brown - Use Yellow
Case 4:    vt100_ColorNumber = 1 'Blue
Case 5:    vt100_ColorNumber = 5 'Magenta
Case 6:    vt100_ColorNumber = 3 'Cyan
Case 7:    vt100_ColorNumber = 7 'White
Case Else: vt100_ColorNumber = 0
End Select

End Function

